#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <stdint.h>
#include <unistd.h>
#include <libusb-1.0/libusb.h>

#define TEST_J	0x1
#define TEST_K	0x2
#define TEST_SE0_NAK	0x3
#define TEST_PACKET	0x4
#define TEST_FORCE_ENABLE	0x5


unsigned	vid = 0x0bda;
unsigned	pid = 0x5411;
unsigned	test_port_num = 0x1;

int test_mode(libusb_device_handle *hub_devh)
{
	int ret = -1;
	/*
	 * bmRequestType = 0x23, bRequest = 0x03 (SET FEATURE), wValue = 0x15(PORT_TEST)
	 * wIndex = (TEST_ITEM) << 8 | test_port_num (TEST item [15...8] port number [7...0])
	 */
    ret = libusb_control_transfer(hub_devh, 0x23, 0x03, 0x15, ((TEST_J<<8)|(test_port_num)), 0, 0, 100000);
    if (ret < 0) {
        printf("[error]:test mode command fail.\n");
    }
	
	return ret;	
}

int main(int argc, char *argv[])
{
    int ret=0;
    libusb_device_handle	*hub_devh;
    libusb_context		*context;

    ret = libusb_init(&context);
    if (ret != 0){
        printf("[error]:libusb init fail.\n");
        return ret;
    }
    
    hub_devh = libusb_open_device_with_vid_pid(context, vid, pid);
    if (!hub_devh) {
        printf("[error]:open device %04x:%04x fail.\n", vid, pid);
		return -1;
	}
    ret = test_mode(hub_devh);
    return ret;
}

